StringResource (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.types.resources, class: StringResource

# Class StringResource

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.Resource
org.apache.tools.ant.types.resources.StringResource

All Implemented Interfaces:
  `Cloneable, Comparable<Resource>, Iterable<Resource>, ResourceCollection`

public class StringResource extends Resource
Exposes a string as a Resource.

Since:
  Ant 1.7

- ## Field Summary

  ### Fields inherited from class Resource

  `MAGIC, UNKNOWN_DATETIME, UNKNOWN_SIZE`
  Modifier and Type
  Field
  Description
  `protected static final int`
  `MAGIC`
  Magic number
  `static final long`
  `UNKNOWN_DATETIME`
  Constant unknown datetime for getLastModified
  `static final long`
  `UNKNOWN_SIZE`
  Constant unknown size

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `StringResource()`
  Default constructor.
  `StringResource(String value)`
  Construct a StringResource with the supplied value.
  `StringResource(Project project, String value)`
  Construct a StringResource with the supplied project and value, doing property replacement against the project if non-null.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addText(String text)`
  Add nested text to this resource.
  `protected String`
  `getContent()`
  Get the content of this StringResource.
  `String`
  `getEncoding()`
  Get the encoding used by this StringResource.
  `InputStream`
  `getInputStream()`
  Get an InputStream for the Resource.
  `String`
  `getName()`
  Synchronize access.
  `OutputStream`
  `getOutputStream()`
  Get an OutputStream for the Resource.
  `protected StringResource`
  `getRef()`
  Perform the check for circular references and return the referenced Resource.
  `long`
  `getSize()`
  Get the size of this Resource.
  `String`
  `getValue()`
  Get the value of this StringResource, resolving to the root reference if needed.
  `int`
  `hashCode()`
  Get the hash code for this Resource.
  `boolean`
  `isExists()`
  The exists attribute tells whether a resource exists.
  `void`
  `setEncoding(String s)`
  Set the encoding to be used for this StringResource.
  `void`
  `setName(String s)`
  Enforce String immutability.
  `void`
  `setRefid(Reference r)`
  Overrides the super version.
  `void`
  `setValue(String s)`
  The value attribute is a semantically superior alias for the name attribute.
  `String`
  `toString()`
  Get the string.

  ### Methods inherited from class Resource

  `as, asOptional, clone, compareTo, equals, getLastModified, getMagicNumber, isDirectory, isFilesystemOnly, iterator, setDirectory, setExists, setLastModified, setSize, size, toLongString`
  Modifier and Type
  Method
  Description
  `<T> T`
  `as(Class<T> clazz)`
  Returns a view of this resource that implements the interface given as the argument or null if there is no such view.
  `<T> Optional<T>`
  `asOptional(Class<T> clazz)`
  Return `Resource.as(Class)` as an `Optional`.
  `Object`
  `clone()`
  Clone this Resource.
  `int`
  `compareTo(Resource other)`
  Delegates to a comparison of names.
  `boolean`
  `equals(Object other)`
  Implement basic Resource equality.
  `long`
  `getLastModified()`
  Tells the modification time in milliseconds since 01.01.1970 (the "epoch").
  `protected static int`
  `getMagicNumber(byte[] seed)`
  Create a "magic number" for use in hashCode calculations.
  `boolean`
  `isDirectory()`
  Tells if the resource is a directory.
  `boolean`
  `isFilesystemOnly()`
  Fulfill the ResourceCollection contract.
  `Iterator<Resource>`
  `iterator()`
  Fulfill the ResourceCollection contract.
  `void`
  `setDirectory(boolean directory)`
  Set the directory attribute.
  `void`
  `setExists(boolean exists)`
  Set the exists attribute.
  `void`
  `setLastModified(long lastmodified)`
  Set the last modification attribute.
  `void`
  `setSize(long size)`
  Set the size of this Resource.
  `int`
  `size()`
  Fulfill the ResourceCollection contract.
  `final String`
  `toLongString()`
  Get a long String representation of this Resource.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, dieOnCircularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, tooManyAttributes`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Stack<Object> stack, Project project)`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Iterable

  `forEach, spliterator`

  ### Methods inherited from interface ResourceCollection

  `isEmpty, stream`
  Modifier and Type
  Method
  Description
  `default boolean`
  `isEmpty()`
  Learn whether this `ResourceCollection` is empty.
  `default Stream<? extends Resource>`
  `stream()`
  Return a `Stream` over this `ResourceCollection`.

- ## Constructor Details

  - ### StringResource

    public StringResource()
    Default constructor.

  - ### StringResource

    public StringResource(String value)
    Construct a StringResource with the supplied value.
    Parameters:
      `value` - the value of this StringResource.

  - ### StringResource

    public StringResource(Project project, String value)
    Construct a StringResource with the supplied project and value, doing property replacement against the project if non-null.
    Parameters:
      `project` - the owning Project.
      `value` - the value of this StringResource.

- ## Method Details

  - ### setName

    public void setName(String s)
    Enforce String immutability.
    Overrides:
      `setName` in class `Resource`
    Parameters:
      `s` - the new name/value for this StringResource.

  - ### setValue

    public void setValue(String s)
    The value attribute is a semantically superior alias for the name attribute.
    Parameters:
      `s` - the String's value.

  - ### getName

    public String getName()
    Synchronize access.
    Overrides:
      `getName` in class `Resource`
    Returns:
      the name/value of this StringResource.

  - ### getValue

    public String getValue()
    Get the value of this StringResource, resolving to the root reference if needed.
    Returns:
      the represented String.

  - ### isExists

    public boolean isExists()
    The exists attribute tells whether a resource exists.
    Overrides:
      `isExists` in class `Resource`
    Returns:
      true if this resource exists.

  - ### addText

    public void addText(String text)
    Add nested text to this resource. Properties will be expanded during this process.
    Parameters:
      `text` - text to use as the string resource
    Since:
      Ant 1.7.1

  - ### setEncoding

    public void setEncoding(String s)
    Set the encoding to be used for this StringResource.
    Parameters:
      `s` - the encoding name.

  - ### getEncoding

    public String getEncoding()
    Get the encoding used by this StringResource.
    Returns:
      the encoding name.

  - ### getSize

    public long getSize()
    Get the size of this Resource.
    Overrides:
      `getSize` in class `Resource`
    Returns:
      the size, as a long, 0 if the Resource does not exist (for compatibility with java.io.File), or UNKNOWN_SIZE if not known.

  - ### hashCode

    public int hashCode()
    Get the hash code for this Resource.
    Overrides:
      `hashCode` in class `Resource`
    Returns:
      hash code as int.

  - ### toString

    public String toString()
    Get the string. See `getContent()`
    Overrides:
      `toString` in class `Resource`
    Returns:
      the string contents of the resource.
    Since:
      Ant 1.7

  - ### getInputStream

    public InputStream getInputStream() throws IOException
    Get an InputStream for the Resource.
    Overrides:
      `getInputStream` in class `Resource`
    Returns:
      an InputStream containing this Resource's content.
    Throws:
      `IOException` - if unable to provide the content of this Resource as a stream.
      `UnsupportedOperationException` - if InputStreams are not supported for this Resource type.

  - ### getOutputStream

    public OutputStream getOutputStream() throws IOException
    Get an OutputStream for the Resource.
    Overrides:
      `getOutputStream` in class `Resource`
    Returns:
      an OutputStream to which content can be written.
    Throws:
      `IOException` - if unable to provide the content of this Resource as a stream.
      `UnsupportedOperationException` - if OutputStreams are not supported for this Resource type.

  - ### setRefid

    public void setRefid(Reference r)
    Overrides the super version.
    Overrides:
      `setRefid` in class `Resource`
    Parameters:
      `r` - the Reference to set.

  - ### getContent

    protected String getContent()
    Get the content of this StringResource. See `getValue()`
    Returns:
      a String or null if there is no value.

  - ### getRef

    protected StringResource getRef()
    Description copied from class: `Resource`
    Perform the check for circular references and return the referenced Resource.
    Overrides:
      `getRef` in class `Resource`
    Returns:
      `Resource`.